local scene = getCurrentScene()
local viewport = Viewport(scene:getObjectByName("viewport"))
local componentInterface = getComponentInterface()

local apiVersion = "1.0"

function trackingCallback(notify, id, iTargetIndex, keyframeIndex, position, orientation)
	Px, Py, Pz  = position:get()
	Qx, Qy, Qz, Qw = orientation:get()
	
	-- Separate to three functions?? 
	componentInterface:executeAppFunc("trackingCallback",
		apiVersion, string.format("%d",notify), string.format("%d",id),
		string.format("%d",iTargetIndex),string.format("%d",keyframeIndex),
		string.format("%f", Px), string.format("%f", Py), string.format("%f", Pz),
		string.format("%f", Qw), string.format("%f", Qx), string.format("%f", Qy), string.format("%f", Qz))

end

function eventCallback(reqCode, tag, code, message, argsCsv)
	componentInterface:executeAppFunc("luaEventCallback",
		apiVersion, string.format("%d",reqCode), tag, string.format("%d",code), message, argsCsv)
end

function touchCallback(targetIndex, keyFrameIndex, objName, tapNum, x, y)
	componentInterface:executeAppFunc("luaTouchCallback",
		apiVersion, string.format("%d",targetIndex), string.format("%d",keyFrameIndex), objName, string.format("%d",tapNum), string.format("%d",x), string.format("%d",y))
end

function luaTakePictureCallback(filepath)
	componentInterface:executeAppFunc("luaTakePictureCallback",
		apiVersion, filepath)
end

function luaExternalFuncCallback(action, uri)
	componentInterface:executeAppFunc("luaExternalFuncCallback",
		apiVersion, action, uri)
end
